"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var generator_1 = require("../../../generator");
var ModelUpdateManyInputTypeGenerator = /** @class */ (function (_super) {
    __extends(ModelUpdateManyInputTypeGenerator, _super);
    function ModelUpdateManyInputTypeGenerator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModelUpdateManyInputTypeGenerator.prototype.getTypeName = function (input, args) {
        return input.name + "UpdateManyInput";
    };
    ModelUpdateManyInputTypeGenerator.prototype.wouldBeEmpty = function (model, args) {
        var writeableFields = this.getWriteableFields(model.fields);
        return this.generators.modelCreateInput.wouldBeEmpty(model, args) &&
            (this.generators.modelWhereUniqueInput.wouldBeEmpty(model, args) || writeableFields.length === 0) &&
            this.generators.modelScalarWhereInput.wouldBeEmpty(model, args) &&
            this.generators.modelUpdateManyWithWhereNestedInput.wouldBeEmpty(model, args);
    };
    ModelUpdateManyInputTypeGenerator.prototype.generateFields = function (model, args) {
        var fields = {};
        var writeableFields = this.getWriteableFields(model.fields);
        if (!this.generators.modelCreateInput.wouldBeEmpty(model, args)) {
            fields.create = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelCreateInput.generate(model, args)) };
        }
        if (writeableFields.length > 0 && !this.generators.modelWhereUniqueInput.wouldBeEmpty(model, args)) {
            fields.update = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelUpdateWithWhereUniqueNestedInput.generate(model, args)) };
            fields.upsert = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelUpsertWithWhereUniqueNestedInput.generate(model, args)) };
        }
        if (!this.generators.modelWhereUniqueInput.wouldBeEmpty(model, args)) {
            fields.delete = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelWhereUniqueInput.generate(model, args)) };
            if (!model.isEmbedded) {
                fields.connect = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelWhereUniqueInput.generate(model, args)) };
                fields.disconnect = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelWhereUniqueInput.generate(model, args)) };
            }
        }
        if (!this.generators.modelScalarWhereInput.wouldBeEmpty(model, args)) {
            fields.deleteMany = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelScalarWhereInput.generate(model, args)) };
        }
        if (!this.generators.modelUpdateManyWithWhereNestedInput.wouldBeEmpty(model, args)) {
            fields.updateMany = { type: this.generators.scalarTypeGenerator.wrapList(this.generators.modelUpdateManyWithWhereNestedInput.generate(model, args)) };
        }
        return fields;
    };
    return ModelUpdateManyInputTypeGenerator;
}(generator_1.ModelInputObjectTypeGenerator));
exports.default = ModelUpdateManyInputTypeGenerator;
//# sourceMappingURL=modelUpdateManyInputGenerator.js.map