import { ModelInputObjectTypeGenerator } from '../../generator';
import { IGQLType, IGQLField } from 'prisma-datamodel';
import { GraphQLInputFieldConfigMap } from "graphql/type";
import { GraphQLInputType } from 'graphql';
export default class ModelWhereInputGenerator extends ModelInputObjectTypeGenerator {
    static generateFiltersForSuffix(suffixes: string[], modelField: IGQLField | null, gqlType: GraphQLInputType): GraphQLInputFieldConfigMap;
    getTypeName(input: IGQLType, args: {}): string;
    generateScalarFilterFields(model: IGQLType, field: IGQLField): GraphQLInputFieldConfigMap;
    generateBaseFilters(field: IGQLField): GraphQLInputFieldConfigMap;
    generateInclusionFilters(field: IGQLField): GraphQLInputFieldConfigMap;
    generateAlphanumericFilters(field: IGQLField): GraphQLInputFieldConfigMap;
    generateStringFilters(field: IGQLField): GraphQLInputFieldConfigMap;
    generateRelationFilterFields(model: IGQLType, field: IGQLField): GraphQLInputFieldConfigMap | null;
    generateOneRelationFilterFields(field: IGQLField): GraphQLInputFieldConfigMap;
    generateManyRelationFilterFields(field: IGQLField): GraphQLInputFieldConfigMap;
    protected generateFields(model: IGQLType, args: {}): GraphQLInputFieldConfigMap;
}
